const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const subscriptions = sequelize.define(
    'subscriptions',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

provider: {
        type: DataTypes.TEXT,
      
      

      },

provider_subscription_ref: {
        type: DataTypes.TEXT,
      
      

      },

tier: {
        type: DataTypes.ENUM,
      
      

        values: [

"free",


"starter",


"premium"

        ],

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"active",


"past_due",


"canceled",


"trialing",


"incomplete",


"incomplete_expired",


"unpaid"

        ],

      },

current_period_start_at: {
        type: DataTypes.DATE,
      
      

      },

current_period_end_at: {
        type: DataTypes.DATE,
      
      

      },

cancel_at_period_end: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

canceled_at: {
        type: DataTypes.DATE,
      
      

      },

price_ref: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  subscriptions.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity































//end loop



    db.subscriptions.belongsTo(db.users, {
      as: 'user',
      foreignKey: {
        name: 'userId',
      },
      constraints: false,
    });




    db.subscriptions.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.subscriptions.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return subscriptions;
};


